submodule: Use cat instead of echo to avoid DOS line-endings
[git/dscho.git] / git-pull.sh
blob8c1370f81bfa95832de99d78aa3bee4f763b821a
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano
5 # Fetch one or more remote refs and merge it/them into the current HEAD.
7 USAGE='[-n | --no-stat] [--[no-]commit] [--[no-]squash] [--[no-]ff] [-s strategy]... [<fetch-options>] <repo> <head>...'
8 LONG_USAGE='Fetch one or more remote refs and merge it/them into the current HEAD.'
9 SUBDIRECTORY_OK=Yes
10 OPTIONS_SPEC=
11 . git-sh-setup
12 . git-sh-i18n
13 set_reflog_action "pull${1+ $*}"
14 require_work_tree
15 cd_to_toplevel
18 die_conflict () {
19 git diff-index --cached --name-status -r --ignore-submodules HEAD --
20 if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
21 die "$(gettext "Pull is not possible because you have unmerged files.
22 Please, fix them up in the work tree, and then use 'git add/rm <file>'
23 as appropriate to mark resolution, or use 'git commit -a'.")"
24 else
25 die "$(gettext "Pull is not possible because you have unmerged files.")"
29 die_merge () {
30 if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
31 die "$(gettext "You have not concluded your merge (MERGE_HEAD exists).
32 Please, commit your changes before you can merge.")"
33 else
34 die "$(gettext "You have not concluded your merge (MERGE_HEAD exists).")"
38 test -z "$(git ls-files -u)" || die_conflict
39 test -f "$GIT_DIR/MERGE_HEAD" && die_merge
41 strategy_args= diffstat= no_commit= squash= no_ff= ff_only=
42 log_arg= verbosity= progress= recurse_submodules=
43 merge_args=
44 curr_branch=$(git symbolic-ref -q HEAD)
45 curr_branch_short="${curr_branch#refs/heads/}"
46 rebase=$(git config --bool branch.$curr_branch_short.rebase)
47 dry_run=
48 while :
50 case "$1" in
51 -q|--quiet)
52 verbosity="$verbosity -q" ;;
53 -v|--verbose)
54 verbosity="$verbosity -v" ;;
55 --progress)
56 progress=--progress ;;
57 --no-progress)
58 progress=--no-progress ;;
59 -n|--no-stat|--no-summary)
60 diffstat=--no-stat ;;
61 --stat|--summary)
62 diffstat=--stat ;;
63 --log|--no-log)
64 log_arg=$1 ;;
65 --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
66 no_commit=--no-commit ;;
67 --c|--co|--com|--comm|--commi|--commit)
68 no_commit=--commit ;;
69 --sq|--squ|--squa|--squas|--squash)
70 squash=--squash ;;
71 --no-sq|--no-squ|--no-squa|--no-squas|--no-squash)
72 squash=--no-squash ;;
73 --ff)
74 no_ff=--ff ;;
75 --no-ff)
76 no_ff=--no-ff ;;
77 --ff-only)
78 ff_only=--ff-only ;;
79 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
80 --strateg=*|--strategy=*|\
81 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
82 case "$#,$1" in
83 *,*=*)
84 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
85 1,*)
86 usage ;;
88 strategy="$2"
89 shift ;;
90 esac
91 strategy_args="${strategy_args}-s $strategy "
93 -X*)
94 case "$#,$1" in
95 1,-X)
96 usage ;;
97 *,-X)
98 xx="-X $(git rev-parse --sq-quote "$2")"
99 shift ;;
100 *,*)
101 xx=$(git rev-parse --sq-quote "$1") ;;
102 esac
103 merge_args="$merge_args$xx "
105 -r|--r|--re|--reb|--reba|--rebas|--rebase)
106 rebase=true
108 --no-r|--no-re|--no-reb|--no-reba|--no-rebas|--no-rebase)
109 rebase=false
111 --recurse-submodules)
112 recurse_submodules=--recurse-submodules
114 --recurse-submodules=*)
115 recurse_submodules="$1"
117 --no-recurse-submodules)
118 recurse_submodules=--no-recurse-submodules
120 --d|--dr|--dry|--dry-|--dry-r|--dry-ru|--dry-run)
121 dry_run=--dry-run
123 -h|--help-all)
124 usage
127 # Pass thru anything that may be meant for fetch.
128 break
130 esac
131 shift
132 done
134 error_on_no_merge_candidates () {
135 exec >&2
136 for opt
138 case "$opt" in
139 -t|--t|--ta|--tag|--tags)
140 echo "Fetching tags only, you probably meant:"
141 echo " git fetch --tags"
142 exit 1
143 esac
144 done
146 if test true = "$rebase"
147 then
148 op_type=rebase
149 op_prep=against
150 else
151 op_type=merge
152 op_prep=with
155 curr_branch=${curr_branch#refs/heads/}
156 upstream=$(git config "branch.$curr_branch.merge")
157 remote=$(git config "branch.$curr_branch.remote")
159 if [ $# -gt 1 ]; then
160 if [ "$rebase" = true ]; then
161 printf "There is no candidate for rebasing against "
162 else
163 printf "There are no candidates for merging "
165 echo "among the refs that you just fetched."
166 echo "Generally this means that you provided a wildcard refspec which had no"
167 echo "matches on the remote end."
168 elif [ $# -gt 0 ] && [ "$1" != "$remote" ]; then
169 echo "You asked to pull from the remote '$1', but did not specify"
170 echo "a branch. Because this is not the default configured remote"
171 echo "for your current branch, you must specify a branch on the command line."
172 elif [ -z "$curr_branch" -o -z "$upstream" ]; then
173 . git-parse-remote
174 error_on_missing_default_upstream "pull" $op_type $op_prep \
175 "git pull <repository> <refspec>"
176 else
177 echo "Your configuration specifies to $op_type $op_prep the ref '${upstream#refs/heads/}'"
178 echo "from the remote, but no such ref was fetched."
180 exit 1
183 test true = "$rebase" && {
184 if ! git rev-parse -q --verify HEAD >/dev/null
185 then
186 # On an unborn branch
187 if test -f "$GIT_DIR/index"
188 then
189 die "$(gettext "updating an unborn branch with changes added to the index")"
191 else
192 require_clean_work_tree "pull with rebase" "Please commit or stash them."
194 oldremoteref= &&
195 . git-parse-remote &&
196 remoteref="$(get_remote_merge_branch "$@" 2>/dev/null)" &&
197 oldremoteref="$(git rev-parse -q --verify "$remoteref")" &&
198 for reflog in $(git rev-list -g $remoteref 2>/dev/null)
200 if test "$reflog" = "$(git merge-base $reflog $curr_branch)"
201 then
202 oldremoteref="$reflog"
203 break
205 done
207 orig_head=$(git rev-parse -q --verify HEAD)
208 git fetch $verbosity $progress $dry_run $recurse_submodules --update-head-ok "$@" || exit 1
209 test -z "$dry_run" || exit 0
211 curr_head=$(git rev-parse -q --verify HEAD)
212 if test -n "$orig_head" && test "$curr_head" != "$orig_head"
213 then
214 # The fetch involved updating the current branch.
216 # The working tree and the index file is still based on the
217 # $orig_head commit, but we are merging into $curr_head.
218 # First update the working tree to match $curr_head.
220 eval_gettextln "Warning: fetch updated the current branch head.
221 Warning: fast-forwarding your working tree from
222 Warning: commit \$orig_head." >&2
223 git update-index -q --refresh
224 git read-tree -u -m "$orig_head" "$curr_head" ||
225 die "$(eval_gettext "Cannot fast-forward your working tree.
226 After making sure that you saved anything precious from
227 $ git diff \$orig_head
228 output, run
229 $ git reset --hard
230 to recover.")"
234 merge_head=$(sed -e '/ not-for-merge /d' \
235 -e 's/ .*//' "$GIT_DIR"/FETCH_HEAD | \
236 tr '\012' ' ')
238 case "$merge_head" in
240 error_on_no_merge_candidates "$@"
242 ?*' '?*)
243 if test -z "$orig_head"
244 then
245 die "$(gettext "Cannot merge multiple branches into empty head")"
247 if test true = "$rebase"
248 then
249 die "$(gettext "Cannot rebase onto multiple branches")"
252 esac
254 if test -z "$orig_head"
255 then
256 git update-ref -m "initial pull" HEAD $merge_head "$curr_head" &&
257 git read-tree -m -u HEAD || exit 1
258 exit
261 if test true = "$rebase"
262 then
263 o=$(git show-branch --merge-base $curr_branch $merge_head $oldremoteref)
264 if test "$oldremoteref" = "$o"
265 then
266 unset oldremoteref
270 merge_name=$(git fmt-merge-msg $log_arg <"$GIT_DIR/FETCH_HEAD") || exit
271 case "$rebase" in
272 true)
273 eval="git-rebase $diffstat $strategy_args $merge_args"
274 eval="$eval --onto $merge_head ${oldremoteref:-$merge_head}"
277 eval="git-merge $diffstat $no_commit $squash $no_ff $ff_only"
278 eval="$eval $log_arg $strategy_args $merge_args $verbosity $progress"
279 eval="$eval \"\$merge_name\" HEAD $merge_head"
281 esac
282 eval "exec $eval"